package com.jasamedika.medifirst2000.converter;

import java.lang.reflect.Field;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;

import javax.persistence.Column;
import javax.persistence.JoinColumn;
import javax.persistence.OneToMany;

import org.springframework.stereotype.Component;

import com.google.gson.Gson;
import com.jasamedika.medifirst2000.converter.base.BaseVoConverter;
import com.jasamedika.medifirst2000.entities.DetailSWOT;
import com.jasamedika.medifirst2000.vo.DetailSWOTVO;

@Component
public class DetailSWOTConverter implements BaseVoConverter<DetailSWOTVO,DetailSWOT>{

	@Override
	public DetailSWOT transferVOToModel(DetailSWOTVO vo, DetailSWOT model) {
		if (null == model)
			model = new DetailSWOT();

		try {
			String[] fieldsToInclude = null;
			Map<String, Object> serialized = vo.serialize(fieldsToInclude,vo.getClass().getName());
			Gson gson = new Gson();
	        String json = gson.toJson(serialized);
	        model = gson.fromJson(json, DetailSWOT.class);
		} catch (Exception e) {
			e.printStackTrace();
		}
		
		return model;
	}

	@Override
	public List<DetailSWOTVO> transferListOfModelToListOfVO(List<DetailSWOT> models, List<DetailSWOTVO> vos) {

		if (null == vos)
			vos = new ArrayList<DetailSWOTVO>();

		if (null == models)
			return vos;

		for (DetailSWOT pegawai : models) {
			DetailSWOTVO vo = new DetailSWOTVO();
			vo=transferModelToVO(pegawai, vo);
			vos.add(vo);
		}

		return vos;
	}

	@Override
	public DetailSWOTVO transferModelToVO(DetailSWOT model, DetailSWOTVO vo) {
		if (null == vo)
			vo = new DetailSWOTVO();
		try {
			
			List<String> fieldsToInclude = new ArrayList<String>();
			for (Field field : model.GetFields(model.getClass())) {
				String str = field.getName();
				String name = field.getName();
				if(name.equals("serialVersionUID"))continue;
				Boolean valid = false;
				for (java.lang.annotation.Annotation annotation : field.getDeclaredAnnotations()) {
					if (annotation instanceof JoinColumn) {
						valid=true;
					} else if (annotation instanceof Column) {
						Column column = (Column)annotation; 
						if(column.name().endsWith("Fk"))
							if(field.getName().endsWith("Id")==false)
								valid=true;
					}else if (annotation instanceof OneToMany) {
						
						valid=true;
					}
						
				}
				if(valid ==false)
					fieldsToInclude.add(str);
				
			}
			Map<String, Object> serialized = model.serialize(fieldsToInclude.toArray(new String[0]),model.getClass().getSimpleName());
			Gson gson = new Gson();
			String json = gson.toJson(serialized);
	        vo = gson.fromJson(json, DetailSWOTVO.class);
		} catch (Exception e) {
			e.printStackTrace();
		}

		return vo;
	}
	
	public DetailSWOTVO transferModelToVOCustom(DetailSWOT model, DetailSWOTVO vo,String[] fieldsToInclude) {
		if (null == vo)

		vo = new DetailSWOTVO();

		try {
			Map<String, Object> serialized = model.serialize(fieldsToInclude,model.getClass().getSimpleName());
			Gson gson = new Gson();
	        String json = gson.toJson(serialized);
	        vo = gson.fromJson(json, DetailSWOTVO.class);
		} catch (Exception e) {
			e.printStackTrace();
		}
		return vo;
	}
	
}
